//+------------------------------------------------------------------+
//|                                             stealth_SL_TP_BE.mq4 |
//|                      Copyright  2009, Silas Palmer              |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Silas Palmer"

extern  bool        use_hidden_stop_loss = True;
extern double          hidden_sl    = 0.0001;
extern  bool        use_hidden_take_profit = True;
extern  double         hidden_tp    = 5.0001;
extern  bool        use_move_sl_to_break_even = True;
extern  double         sl_to_break_even    = 4.0001; 


 void hidden_take_profit()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if ( OrderSymbol()==Symbol()  )
     {
  if (OrderType() == OP_BUY &&  hidden_tp <= Bid )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
  if (OrderType() == OP_SELL &&  hidden_tp >= Ask  )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
  
      }
  }
  return;
}

void hidden_stop_loss()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if ( OrderSymbol()==Symbol()  )
     {
  if (OrderType() == OP_BUY &&  hidden_sl >= Bid )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
  if (OrderType() == OP_SELL &&  hidden_sl <= Ask  )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
  
      }
  }
  return;
}


void move_sl_to_break_even()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if ( OrderSymbol()==Symbol()  )
     {
  if (OrderType() == OP_BUY &&  sl_to_break_even <= Bid && hidden_sl != OrderOpenPrice() + (Point * MarketInfo(Symbol(),MODE_SPREAD)))  hidden_sl = OrderOpenPrice() + (Point * MarketInfo(Symbol(),MODE_SPREAD));
  if (OrderType() == OP_SELL &&  sl_to_break_even >= Ask && hidden_sl != OrderOpenPrice() - (Point * MarketInfo(Symbol(),MODE_SPREAD)))  hidden_sl = OrderOpenPrice() - (Point * MarketInfo(Symbol(),MODE_SPREAD));
  
      }
  }
  return;
}


int start()
  {
   
   if (use_hidden_stop_loss)             hidden_stop_loss();
   if (use_hidden_take_profit)         hidden_take_profit();
   if (use_move_sl_to_break_even)   move_sl_to_break_even();
   return(0);
  }

